\section{blinky}
In the following the script, to be found under \verb=src/bin/blinky.rs= is explained. 
This is a simple blinker program for the \pico.
\begin{figure}[H]
	\centering
	{\tiny \lstinputlisting[linerange={1-2}]{../src/bin/blinky.rs}}
	\caption{
	These two macros ensure that no standard libraries are used, since these do not readily exist 
	in an environment without an operating system. Instead, the \textit{core-crate} is used. The 
	other macro changes the behavior of the main method so that it runs on a microchip without 
	further ado.
	}
\end{figure}
\begin{figure}[H]
	\centering
	{\tiny \lstinputlisting[linerange={3-3}]{../src/bin/blinky.rs}}
	\caption{
	With hardware close programming, inaccuracies may occur due to physical conditions alone. 
	Since RUST is a programming language with special attention to memory security, this memory 
	security must be softened slightly at this point.
	}
\end{figure}
\begin{figure}[H]
	\centering
	{\tiny \lstinputlisting[linerange={4-4}]{../src/bin/blinky.rs}}
	\caption{
Since this crate is called in very many places in the script, the alias is changed to minimize write overhead.
	}
\end{figure}
\begin{figure}[H]
	\centering
	{\tiny \lstinputlisting[linerange={6-6}]{../src/bin/blinky.rs}}
	\caption{
The pins used in this example should be switchable without the need to explicitly specify their initial state in the code.
	}
\end{figure}
\begin{figure}[H]
	\centering
	{\tiny \lstinputlisting[linerange={7-9}]{../src/bin/blinky.rs}}
	\caption{
Instruction for the linker to control the correct bootloader for the \pico on, which is directly 
applied via the following macro. The following crate provides for the integration in the program.
	}
\end{figure}
\begin{figure}[H]
	\centering
	{\tiny \lstinputlisting[linerange={10-10}]{../src/bin/blinky.rs}}
	\caption{
External high-speed crystal on the Raspberry Pi Pico board is 12 MHz
	}
\end{figure}
\begin{figure}[H]
	\centering
	{\tiny \lstinputlisting[linerange={11-11}]{../src/bin/blinky.rs}}
	\caption{
Entry point for the program.
	}
\end{figure}
\begin{figure}[H]
	\centering
	{\tiny \lstinputlisting[linerange={13-14}]{../src/bin/blinky.rs}}
	\caption{
These two variables must be implemented as singletons.
	}
\end{figure}
\begin{figure}[H]
	\centering
	{\tiny \lstinputlisting[linerange={15-15}]{../src/bin/blinky.rs}}
	\caption{
Set up the watchdog driver - needed by the clock setup code
	}
\end{figure}
\begin{figure}[H]
	\centering
	{\tiny \lstinputlisting[linerange={16-26}]{../src/bin/blinky.rs}}
	\caption{
Configure the clocks. This is pretty standard for this chip.
	}
\end{figure}
\begin{figure}[H]
	\centering
	{\tiny \lstinputlisting[linerange={16-26}]{../src/bin/blinky.rs}}
	\caption{
Configure the clocks. This is pretty standard for this chip.
	}
\end{figure}
\begin{figure}[H]
	\centering
	{\tiny \lstinputlisting[linerange={27-27}]{../src/bin/blinky.rs}}
	\caption{
System timer (SysTick) as a delay provider.
	}
\end{figure}
\begin{figure}[H]
	\centering
	{\tiny \lstinputlisting[linerange={28-28}]{../src/bin/blinky.rs}}
	\caption{
The single-cycle I/O block controls our GPIO pins
	}
\end{figure}
\begin{figure}[H]
	\centering
	{\tiny \lstinputlisting[linerange={29-34}]{../src/bin/blinky.rs}}
	\caption{
Set the pins to their default state
	}
\end{figure}
\begin{figure}[H]
	\centering
	{\tiny \lstinputlisting[linerange={35-40}]{../src/bin/blinky.rs}}
	\caption{
Sets all specified pins to output state, so you can't take input. The underlying PIins are controlled using a struct with the name of the respective pin.
	}
\end{figure}
\begin{figure}[H]
	\centering
	{\tiny \lstinputlisting[linerange={41-53}]{../src/bin/blinky.rs}}
	\caption{
Here the output of the pins is changed between 0 and 1.
	}
\end{figure}
